c     ------------------------------------------------------------------
c     cycle.F begins                                                   |
c     -                                                                |
      SUBROUTINE RampPwr
#include "Implic.inc"
#include "tscunits.inc"
#include "params.inc"
#include "RayBins.inc"
#include "RayWrk.inc"
#include "PlPr.inc"
cinclude "DqlBins.inc"
#include "FeBins.inc"
#include "WkAry.inc"
#include "Ramppwr.inc"
#include "power.inc"
cinclude "power.inc" new statement Jul 1
      INTEGER iramp, ilowest, iPsiL, iPsiU, retcode
      INTEGER i1stcall, iCurious
      INTEGER iITRsave
      REAL    PraySumL(NRAMPDIM), PqlSumL(NRAMPDIM)
c     Local  values for debugging: PraySumL PqlSumL  ! L==Local
      EXTERNAL FeCalc
      DATA     i1stcall, iPsiL, iCurious
     ^        /       1,     1,    0 /

      call setpwrl(pwrlevel, nrampup, nflat)
      iPsiU = npsi
        i1stcall = 0 
        iITR = 1
        call FeAt0
        call FePrime
        ilowest = 1
        
      do 10 iramp = ilowest, nrampup
c     .                                 rescale power level
         call rspwr(pwrlevel(iramp))
         call setiofl(iramp)
         call RayDamp
         call DqlGen
         iITR = mod(iITR,2) + 1
         call FeCalc(iPsiL, iPsiU)
         call FeWeight
         call FePrime
c        call FeDqlout ! take out June 2000
         if (iCurious .eq. 1) then
            call RfDamp
            call RfHeat
            PraySumL(iramp) = PraySum
            PqlSumL (iramp) = PqlSum
         else
            call PwrDiagn
         endif
c
         call FeConvrg(iramp)
c
 10   continue
      if (iCurious .eq. 1) then
c       call LSCPause
        write(nTSCscrn,'('' iSMO = '',i3,
     ^  '' ; iramp, convergence figure, Pray, Pql: '' )') iSMO
        do 20 iramp = ilowest, nrampup
          write(nTSCscrn,'(i4, 3( 1x,1pe11.4) )')
     ^        iramp, FeCvgAry(iramp),PraySumL(iramp),PqlSumL(iramp) 
 20     continue
c       call LSCPause
      endif
c
c     The issue here is to put the original Maxwellian distribution
c     into the other iteration bin of fe so that a graph can be 
c     constructed later showing the tail drawn out in fe.  See for
c     example this line in pbixio.F, SUBROUTINE Giruzzi
c       call Dql6Norm(Vpar(iv),fe(iv,ip,iOrigMaxwl),nv 
c
        iITRsave = iITR
        iITR = mod(iITR,2) + 1
        call FeAt0
        iITR = iITRsave
c
c
      return
      END
c     -----------------------------------------------------------------
      SUBROUTINE FeConvrg(iramp)
#include "Implic.inc"
#include "params.inc"
#include "FeBins.inc"
#include "RayBins.inc"
#include "Ramppwr.inc"
      INTEGER ip,iv, iramp, inew, iold
      REAL    dum, epss
      DATA    epss / 1.e-32 /
      inew = iITR
      iold = mod(inew,2) + 1
      dum = 0.
      do 20   ip=1,Npsi
        do 10 iv=2,nv-1
          dum = dum + abs(fe(iv,ip,inew)-fe(iv,ip,iold)) /
     ^                   (fe(iv,ip,inew)+fe(iv,ip,iold) + epss)
 10     continue
 20   continue
      FeCvgAry(iramp) = dum/float(nv*npsi)
      return 
      END

      SUBROUTINE setiofl(i)
#include "Implic.inc"
#include "params.inc"
#include "PlPr.inc"
      INTEGER PLflst(NPLFLG), PRflst(NPRFLG), i, j, mkout
      if(i .eq. 1)then
         do 10 j = 1, nPlFlg
            PLflst(j) = PlFlg(j)
 10      continue
         do 20 j = 1, nPrFlg
            PRflst(j) = PrFlg(j)
 20      continue
      endif
      do 30 j = 1, nPlFlg
         PlFlg(j) = FALSE
 30   continue
      do 40 j = 1, nPrFlg
         PrFlg(j) = FALSE
 40   continue
      mkout = FALSE
      do 50 j = 1, NDIAG
         if(i .eq. idiag(j))then
            mkout = TRUE
            go to 100
         endif
 50   continue
c
 100  continue
c
      if(mkout .eq. TRUE)then
         do 60 j = 1, nPlFlg
            PlFlg(j) = PLflst(j)
 60      continue
         do 70 j = 1, nPrFlg
            PrFlg(j) = PRflst(j)
 70      continue
      endif
      return
      END
c     ------------------------------------------------------------------
      SUBROUTINE rspwr(pwrlev)
#include "Implic.inc"
#include "params.inc"
#include "RayBins.inc"
#include "RayWrk.inc"
      INTEGER ir, itor, ipol
      REAL pwrlev
c     initalize power on rays
      ir = 1
      do 10 itor = 1, ntors
      do 10 ipol = 1, npols
         power(1, ir) = TotPwr/float(npols) * Spec(itor) * pwrlev
         ir = ir + 1
 10   continue
      return
      END
c     ------------------------------------------------------------------
      SUBROUTINE setpwrl(pwrlevel, n, nflat)
#include "Implic.inc"
      INTEGER n, i, nflat, nfl
      INTEGER newn, iALGORIT, iORIGINL, iGEOMETR, iLINEAR
      REAL    pwrlevel(n)
      REAL    
     ^        ONE, ONEpt05, ONEpt10, ONEpt15, ONEptEPS
      DATA    ONE, ONEpt05, ONEpt10, ONEpt15, ONEptEPS /
     ^        1.0,    1.05,    1.10,    1.15,     1.15 /
c 1.05^100 = 130; 1.10^100 = 10^4; 1.15^100 = 10^6; 1.20^100 = 10^8

      DATA    iALGORIT, iORIGINL, iGEOMETR, iLINEAR /
     ^               3,        1,        2,       3 /

      if(nflat .lt. 1)then
         nfl = 1
      else
         nfl = nflat
      endif

      if(nflat .ge. n-1)then
         nfl = 1
      else
         nfl = nflat
      endif

      if (iALGORIT .eq. iORIGINL) then
c
c     Original code.  Raise by 2 * each time
c     BEGIN
c     geometric series
      pwrlevel(1) = 1. / (2. ** (n - nfl))
      do 10 i = 2, n - nfl + 1
          pwrlevel(i) = 2. * pwrlevel(i - 1)
  10  continue
      do 20 i = n - nfl + 1, n
          pwrlevel(i) = pwrlevel(n - nfl + 1)
  20  continue
c     END
c     Original code.  Raise by 2 * each time

      else if (iALGORIT .eq. iGEOMETR) then
c     New Geometric Ramp Up

      newn = n
      do i = newn, newn-nfl, -1
         pwrlevel(i) = ONE
      enddo

      do i = newn-nfl-1, 1, -1
         pwrlevel(i) = pwrlevel(i + 1)/ONEptEPS
      enddo

      else if (iALGORIT .ge. iLINEAR) then
c     Linear Ramp Up
      newn = n
      do i = newn, newn-nfl, -1
         pwrlevel(i) = ONE
      enddo

      pwrlevel(newn) = ONE
      do i = 1, newn-nfl
         pwrlevel(i) = float(i)/float(newn-nfl)
      enddo

      endif

      return
      END
c     cycle.F ends                                                     |
c     ------------------------------------------------------------------

